#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include "vect.h"
#include "util.h"
//#include "lum.h"
#include "3dpPc.h"

#define AERA .25
#define EPS 0.01

typedef struct patch_s {
  vec3_t *v;
  int n;
  float aera;
  vec3_t moy;
  vec3_t norm;
  vec3_t color;

  int leaf;
  int origPatch;
  struct patch_s *next;
} patch_t;

patch_t pTab;
int pNbr;

/*extern void loadPatch(char *filename);
  extern void freePatch(void);*/

typedef struct{
  float x;
  int i;
} lala_t;

lala_t lala[100];

float couic(float aa,float da,float l1,float l2,float x1,float x2)
{
  if(fabs(l1-l2)<EPS) 
    return x1+(x2-x1)*da/aa;
  {
    double x,x0=x1-l1*(x2-x1)/(l2-l1);
    double alpha=aa/((x2-x0)*(x2-x0)-(x1-x0)*(x1-x0));
    double delta=sqrt((alpha*(x1-x0)*(x1-x0)+da)/alpha);
    if(l1>l2) x=x0-delta;
    else x=x0+delta;
    if((x1-x)*(x2-x)>0) Error("glouglou");
    return x;
  }
}

// coupe selon un plan
void lalala(patch_t *p,int a,int k,float x,vec3_t v2)
{
  vec3_t w0,w1;
  float l;

  //printf("x=%.3f\n",x);
  vec3Copy(p->v[a],w0);
  vec3Copy(p->v[(a+1)%p->n],w1);
  vec3Sub_(w0,w1);
  if(w1[k]==0.) {vec3Copy(w0,v2);/*printf("l=1/0.\n");*/}
  else {
    l=(x-w0[k])/w1[k];
    //printf("l=%.3f\n",l);
    vec3Scale_(l,w1);
    vec3Add(w0,w1,v2);
  }
}  

void couic2(patch_t *p,int *a,float x,int k,int *b)
{
  vec3_t v;
  float dx=(p->v[*a][k]-p->v[(*a+1)%p->n][k]);
  int i;
  if(dx==0.) return;
  //if((p->v[*a][k]-x)/dx < 0.1) return;
  //if((x-p->v[(*a+1)%p->n][k])/dx < 0.1) {(*a)++;return;}
  // on coupe le segment
  if(b) (*b)++;
  lalala(p,*a,k,x,v);
  p->v=(vec3_t*)realloc(p->v,sizeof(vec3_t)*(p->n+1));
  for(i=p->n-1;i>*a;i--)
    vec3Copy(p->v[i],p->v[i+1]);
  vec3Copy(v,p->v[*a+1]);
  p->n++;
  (*a)++;
}
 
float aeraPatch(patch_t *p)
{
  int i;
  vec3_t s,v;
  vec3CrossProduct(p->v[p->n-1],p->v[0],s);
  for(i=1;i<p->n;i++) {
    vec3CrossProduct(p->v[i-1],p->v[i],v);
    vec3Add_(v,s);
  }
  return fabs(0.5*vec3DotProduct(s,p->norm));
}

int cmpLala(const void *a,const void *b)
{
  if(((const lala_t *)a)->x > ((const lala_t *)b)->x) return 1;
  else return -1;
}

void coupePatch(patch_t *p/*,float oa*/)
{
  int i,j,k,a,b;
  patch_t *ptrt;
  vec3_t v,v2,s,s2,norm,*ptrvec3;
  float x,x1,x2;
  float ae1,ae2,l1,l2;
  float min_[3],max_[3];
  float oa;
  
  vec3Copy(p->norm,norm);

  /*
  if((ptrt=(patch_t*)malloc(sizeof(patch_t)))==NULL) Error("");
  *ptrt=*p;
  ptrt->next=p->next;
  p->next=ptrt;
  p->leaf=0;
  ptrt->leaf=1;
  if((ptrvec3=(vec3_t*)malloc(sizeof(vec3_t)*p->n))==NULL) Error("");
  for(i=0;i<p->n;i++)
    for(j=0;j<3;j++)
      ptrvec3[i][j]=p->v[i][j];
  ptrt->v=ptrvec3;
  p=ptrt;
  pNbr++;

  oa/=2.;
  */

  oa=aeraPatch(p)/2.;
  
  for(i=0;i<p->n;i++) {
    if(i==0) 
      for(j=0;j<3;j++) min_[j]=max_[j]=p->v[0][j];
    else
      for(j=0;j<3;j++) {
	if(min_[j]>p->v[i][j]) min_[j]=p->v[i][j];
	if(max_[j]<p->v[i][j]) max_[j]=p->v[i][j];
      }
  }
  for(j=0;j<3;j++) max_[j]-=min_[j];
  if(max_[0]>max_[1] && max_[0]>max_[2]) k=0;
  else if(max_[1]>max_[2]) k=1;
  else k=2;
    
  for(i=0;i<p->n;i++) {
    lala[i].x=p->v[i][k];
    lala[i].i=i;
  }
  qsort(lala,p->n,sizeof(lala_t),cmpLala);
    
  a=b=lala[0].i;
  x1=lala[0].x;
  ae1=0.;l1=0.;    
  vec3Null(s);
  for(i=1;i<p->n;i++) {
    x2=lala[i].x;
    j=lala[i].i;
    if(j == (a+1)%p->n) { 
      vec3CrossProduct(p->v[a],p->v[j],v);
      vec3Add_(v,s);
      lalala(p,(b-1+p->n)%p->n,k,x2,v2);
      vec3Sub(p->v[j],v2,s2);
      l2=vec3Length(s2);
      vec3CrossProduct(p->v[j],v2,s2);
      vec3CrossProduct(v2,p->v[b],v);
      vec3Add_(v,s2);
      vec3Add_(s,s2);
      if((ae2=fabs(0.5*vec3DotProduct(s2,norm)))>oa) {
	x=couic(ae2-ae1,oa-ae1,l1,l2,x1,x2);
	break;
      }
      a=j;
    }
    else if(j == (b-1+p->n)%p->n) {
      vec3CrossProduct(p->v[j],p->v[b],v);
      vec3Add_(v,s);
      lalala(p,a,k,x2,v2);
      vec3Sub(p->v[j],v2,s2);
      l2=vec3Length(s2);
      vec3CrossProduct(p->v[a],v2,s2);
      vec3CrossProduct(v2,p->v[j],v);
      vec3Add_(v,s2);
      vec3Add_(s,s2);
      if((ae2=fabs(0.5*vec3DotProduct(s2,norm)))>oa) {
	x=couic(ae2-ae1,oa-ae1,l1,l2,x1,x2);
	break;
      }
      b=j;
    }
    else Error("patch pas convexe");
    ae1=ae2;
    l1=l2;
    x1=x2;
  }

  //on coupe
  b=(b-1+p->n)%p->n;
  if(a==b) Error("a==b");
  if(a>b) {int t=a;a=b;b=t;}
  couic2(p,&b,x,k,NULL);
  couic2(p,&a,x,k,&b);

  if((ptrt=(patch_t*)malloc(sizeof(patch_t)))==NULL) Error("");
  ptrt->n=b-a+1;
  ptrt->v=(vec3_t*)malloc((b-a+1)*sizeof(vec3_t));
  for(i=a;i<=b;i++)
    vec3Copy(p->v[i],ptrt->v[i-a]);
  for(i=b;i<p->n;i++)
    vec3Copy(p->v[i],p->v[i-b+a+1]);
  p->n-=b-a-1;
  p->v=(vec3_t*)realloc(p->v,p->n*sizeof(vec3_t));
  vec3Copy(p->norm,ptrt->norm);
    
  ptrt->leaf=1;
  ptrt->origPatch=p->origPatch;
  ptrt->next=p->next;
  p->next=ptrt;
    
  pNbr++;
}

int checkCoupePatch(patch_t *ptrTab)
{
  int i,j,k,a,b;
  patch_t *p=ptrTab,*ptrt;
  vec3_t v,v2,s,s2,norm,*ptrvec3;
  float x,x1,x2,oa;
  float ae1,ae2,l1,l2;
  
  vec3Sub(p->v[1],p->v[0],v);
  vec3Sub(p->v[2],p->v[0],v2);
  vec3CrossProduct(v,v2,norm);
  x=vec3Length(norm);
  if(x==0.) {
    printf("long nulle\n"); //Error("longueur nulle");
    return 0;
  }
  x=1./x;
  vec3Scale_(x,norm);
  vec3Copy(norm,p->norm);
  
  if(aeraPatch(p)>AERA) { // on coupe en 2
    
    if((ptrt=(patch_t*)malloc(sizeof(patch_t)))==NULL) Error("");
    *ptrt=*p;
    ptrt->next=p->next;
    p->next=ptrt;
    p->leaf=0;
    ptrt->leaf=1;
    if((ptrvec3=(vec3_t*)malloc(sizeof(vec3_t)*p->n))==NULL) Error("");
    for(i=0;i<p->n;i++)
      for(j=0;j<3;j++)
	ptrvec3[i][j]=p->v[i][j];
    ptrt->v=ptrvec3;
    p=ptrt;
    pNbr++;
    
    coupePatch(p);
    coupePatch(p->next);
    coupePatch(p);
    
    return 1;
  }
  else p->leaf=1;
  
  return 0;
}

/*
int checkCoupePatch(patch_t *ptrTab)
{
  int i,j,k,a,b;
  patch_t *p=ptrTab,*ptrt;
  vec3_t v,v2,s,s2,norm,*ptrvec3;
  float x,x1,x2,oa;
  float ae1,ae2,l1,l2;
  
  vec3Sub(p->v[1],p->v[0],v);
  vec3Sub(p->v[2],p->v[0],v2);
  vec3CrossProduct(v,v2,norm);
  x=vec3Length(norm);
  if(x==0.) {
    printf("long nulle\n"); //Error("longueur nulle");
    return 0;
  }
  x=1./x;
  vec3Scale_(x,norm);
  vec3Copy(norm,p->norm);

  if((oa=aeraPatch(p))>AERA) { // on coupe en 2
    coupePatch(p,oa);
    return 1;
  }
  else p->leaf=1;
  
  return 0;
}
*/

int main(int argc,char **argv)
{
  char outfile[100],*pt,*infile;
  int i,j,k;
  FILE *in,*out;
  
  patch_t *ptrTab;

  if(argc<2) {printf("usage: %s file.3dpPc [out]\n",argv[0]);exit(1);}

  infile=argv[1];
  if(argc>2) strcpy(outfile,argv[2]);
  else {
    strcpy(outfile,infile);
    for(i=0,j=-1;outfile[i];i++)
      if(outfile[i]=='.') j=i;
    if(j>=0) outfile[j]=0;
    strcat(outfile,".hpatch");
  }
  
  //loadPatch(infile);
  load3dpPc(infile);
  
  for(i=0,ptrTab=pTab.next;ptrTab;ptrTab=ptrTab->next,i++)
    ptrTab->origPatch=i;
  
  printf("%d ->",pNbr);fflush(stdout);
  
  for(ptrTab=pTab.next;ptrTab;) {
    checkCoupePatch(ptrTab); 
    ptrTab=ptrTab->next;
  }
  
  printf("%d\n",pNbr);
  
  if((out=fopen(outfile,"w"))==NULL) Error("ouverture fichier patch2");
  for(ptrTab=pTab.next;ptrTab;ptrTab=ptrTab->next) {
    for(j=0;j<ptrTab->n;j++) {
      fprintf(out,"( ");
      for(k=0;k<3;k++)
	fprintf(out,"%.2f ",ptrTab->v[j][k]);
      fprintf(out,") ");
    }
    fprintf(out,"%d %d\n",ptrTab->origPatch,ptrTab->leaf);
  }
  
  fclose(out);
  
  //freePatch();
  free3dpPc();

  return 0;
}
