#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <GL/glut.h>

#include <time.h>
#include "util.h"
#include "lum.h"
#include "vect.h"

#define sizex 512
#define sizey 512

int normcull=1;

extern void loadPatch(char*);
extern void calcmat(lala_t *,lala_t *,float*,float*,float*,patch_t*,int);

long long int otime;
int r=0;
int l1=-1,l2=100,l0=1,lr=0,l3=0;

float iya=0.;

float vrx=0.0,vry=0.0,vrz=0.0;
//float cx=-5.0,cy=-10.0,cz=-20.0;
float cx=13.0,cy=-5.0,cz=-5.0;

//float* mat;
int pNbr=0;
patch_t *pTab;
float *v,*v2,*v3,*v4,*vl,*vlo;
lala_t *tabskip;
lala_t *mat;
int shoot=-1;


/******************* OPENGL **********************/
static void
idle(void)
{
  glutPostRedisplay();
}

static void
special(int k, int x, int y)
{
  switch (k) {
  case GLUT_KEY_UP:
    vrx+=3;
    break;
  case GLUT_KEY_DOWN:
    vrx-=3;
    break;
  case GLUT_KEY_LEFT:
    vry+=3;
    break;
  case GLUT_KEY_RIGHT:
    vry-=3;
    break;
  default:
    return;
  }
  //printf("(%f %f %f) (%f %f %f)\n",vrx,vry,vrz,cx,cy,cz);
  glutPostRedisplay();
}


int cooll=2;
double cool1=0.6;

static void
key(unsigned char k, int x, int y)
{
#define CD M_PI/180.
  //if(k=='w')
  //  wireframe=1-wireframe;
  //if(k=='p')
  //  plain=1-plain;
  if(k=='y')
    l0=1-l0;
  if(k=='n')
    normcull=1-normcull;
  if(k=='s')
    shoot=1;
  /*
  if(k=='a') {
    
      if(l1!=-1) v2[l1]-=300.;
    else l1=0;
    do{
      l1++;
      if(l1>=pNbr) l1=0;
    } while(pTab[l1].leaf==0);
    v2[l1]+=300.;
  }
  if(k=='z') {
    if(l1!=-1) v2[l1]-=300.;
    else l1=0;
    do{
      l1--;
      if(l1<0) l1=pNbr-1;
    } while(pTab[l1].leaf==0);
    v2[l1]+=300.;
    }*/
  if(k==' ')
    shoot=-1;
  if(k=='+'|| k=='-') { 
    float v[3]={-1.,0.,0.},v2[3];
    v2[1]=v[1];
    v2[0]=cos(vrx*CD)*v[0]-sin(vrx*CD)*v[2];
    v2[2]=sin(vrx*CD)*v[0]+cos(vrx*CD)*v[2];
    v[0]=cos(vry*CD)*v2[0]-sin(vry*CD)*v2[1];
    v[1]=+sin(vry*CD)*v2[0]+cos(vry*CD)*v2[1];
    v[2]=v2[2];
    if(k=='+') {cx+=v[0];cy+=v[1];cz+=v[2];}
    else {cx-=v[0];cy-=v[1];cz-=v[2];}
  }
  //printf("(%f %f %f) (%f %f %f)\n",vrx,vry,vrz,cx,cy,cz);
  //glutPostRedisplay();
  if(k=='*') cool1*=1.1;
  if(k=='/') cool1/=1.1;
  if(k=='l') cooll=(cooll+1)%3;
} 

/*static void
key(unsigned char k, int x, int y)
{
#define CD M_PI/180.
  if(k==' ')
    l0=1-l0;
  if(k=='+'|| k=='-') { 
    float v2[3]={10.,0.,0.},v[3];
    v[0]=cos(vry*CD)*v2[0]+sin(vry*CD)*v2[2];
    v[1]=v2[1];
    v[2]=-sin(vry*CD)*v2[0]+cos(vry*CD)*v2[2];
    v2[0]=cos(vrz*CD)*v[0]+sin(vrz*CD)*v[1];
    v2[1]=-sin(vrz*CD)*v[0]+cos(vrz*CD)*v[1];
    v2[2]=v[2];
    if(k=='+') {cx+=v2[0];cy+=v2[2];cz-=v2[1];}
    else {cx-=v2[0];cy-=v2[2];cz+=v2[1];}
  }
  //glutPostRedisplay();
} */

/* new window size or exposure */
static void
reshape(int width, int height)
{
  GLfloat h = (GLfloat) height / (GLfloat) width;

  glViewport(0, 0, (GLint) width, (GLint) height);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glFrustum(-1.0, 1.0, -h, h, 5.0, 60.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glTranslatef(0.0, 0.0, -40.0);
}

void 
visible(int vis)
{
  if (vis == GLUT_VISIBLE)
    glutIdleFunc(idle);
  else
    glutIdleFunc(NULL);
}

/**************************************/

void addvect(float *v4,float *v5)
{
  int i;
  for(i=0;i<pNbr;i++) {
    v4[i]+=v5[i];
  }
}

void subvect(float *v4,float *v5)
{
  int i;
  for(i=0;i<pNbr;i++) {
    v4[i]-=v5[i];
  }
}

void sumdelta(float *v4)
{
#define HMAX 100
  float tabRec[HMAX];
  int tabInd[HMAX];
  int h;
  int i;

  h=0;
  tabRec[0]=0.;

  for(i=0;i<HMAX;i++) tabInd[i]=0;
  for(i=0;i<pNbr;i++) {
    if(pTab[i].leaf==1) {
      if(h) v4[i]+=tabRec[h-1]/4;
      /*
      glBegin(GL_POLYGON);
      {
	static float color[3]={1.0,0.0,0.0};
	//color[0]=(float)i/pNbr;
	//color[0]=color[1]=color[2]=0.10*(i%10); //+(tabRec[h]+v[i]);
	color[0]=color[1]=color[2]=v4[i];
	glColor3fv(color);
      }
      for(j=0;j<pTab[i].n;j++)
	glVertex3fv(pTab[i].v[j]);
      glEnd();
      */
      tabInd[h]++;
      while(tabInd[h]==4) {
	tabInd[h]=0;
	h--;
	tabInd[h]++;
      }
    } else {
      if(h==0)
	tabRec[0]=v4[i];
      else {
	v4[i]+=tabRec[h-1]/4;
	tabRec[h]=v4[i];
      }
      h++;
    }
    
    if(h==0) {
      tabInd[0]=0;
      tabRec[0]=0.;
    }

  }
}

void sumdelta2(float *v4)
{
#define HMAX 100
  float tabRec[HMAX];
  int tabInd[HMAX];
  int tabP[HMAX];
  int h;
  int i;

  h=0;
  tabRec[0]=0.;

  for(i=0;i<HMAX;i++) tabInd[i]=0;
  for(i=0;i<pNbr;i++) {
    tabP[h]=i;
    int hh;
    float A=v4[i];
    for(hh=h-1;hh>=0;hh--) {
      v4[tabP[hh]]+=A;
      //A/=4.;
    }
    if(pTab[i].leaf==1) {
      if(h) v4[i]+=tabRec[h-1]/4;
      /*
      glBegin(GL_POLYGON);
      {
	static float color[3]={1.0,0.0,0.0};
	//color[0]=(float)i/pNbr;
	//color[0]=color[1]=color[2]=0.10*(i%10); //+(tabRec[h]+v[i]);
	color[0]=color[1]=color[2]=v4[i];
	glColor3fv(color);
      }
      for(j=0;j<pTab[i].n;j++)
	glVertex3fv(pTab[i].v[j]);
      glEnd();
      */
      tabInd[h]++;
      while(tabInd[h]==4) {
	tabInd[h]=0;
	h--;
	tabInd[h]++;
      }
    } else {
      if(h==0)
	tabRec[0]=v4[i];
      else {
	v4[i]+=tabRec[h-1]/4;
	tabRec[h]=v4[i];
      }
      h++;
    }
    
    if(h==0) {
      tabInd[0]=0;
      tabRec[0]=0.;
    }

  }
}


void draw(void)
{
  int i,j;
  float mt[16]={0.,0.,1.,0.,
		0.,-1.,0.,0.,
		1.,0.,0.,0.,
		0.,0.,0.,1.};
  r++;
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  //glPushMatrix();
  
  glClearColor(0.2,0.2,0.4,0.);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  glPolygonMode(GL_FRONT,GL_FILL);
  glPolygonMode(GL_BACK,GL_FILL);
  glFrontFace(GL_CW);
  if(!normcull)
    glDisable(GL_CULL_FACE);
  else
    glEnable(GL_CULL_FACE);

  //glPopMatrix();
  
  glPushMatrix();

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glRotatef(90,0.,0.,1.);
  gluPerspective( /* field of view in degree */ 45.0, /* aspect ratio */ 1.0,
  		  /* Z near */ 0.001, /* Z far */ 4000.0);
  glMatrixMode(GL_MODELVIEW); /* now change to modelview */
  glLoadIdentity();
  //gluLookAt(500, 500.0, 500.0,   /* eye is at (0,0,30) */
  //    0.0, 0.0, 0.0,    /* center is at (0,0,0) */
  //    0.0, 1.0, 0.);    /* up is in postivie Y direction */
  //glPushMatrix();
  
  //glLoadIdentity();
  
  glRotatef(90.+vrx, 0.0, 1.0, 0.0);
  glRotatef(-vry, 0.0, 0.0, 1.0);
  //glRotatef(view_roty, 0.0, 1.0, 0.0);
  
  //glPushMatrix();
  //glTranslatef(-6./md*tmin[0], -6./md*tmin[1], -6./md*tmin[2]-10.0);
  //glTranslatef(-tmin[0], -tmin[1], -tmin[2]-5.0);
  glTranslatef(cx,cy,cz);
  //glScalef(0.01,0.01,0.01);
  
  
  //glRotatef(angle, 0.0, 0.0, 1.0);
  
  //glPopMatrix();
  
  //glShadeModel(GL_FLAT);
  glShadeModel(GL_SMOOTH);

  for(i=0;i<pNbr;i++) {
    //v[i]=0;
    //v3[i]=0;
  }
  
  if(shoot !=0) {
    if(shoot!=-1) shoot--;
    calcmat(tabskip,mat,v,v2,v3,pTab,pNbr);
  }
 
  
  for(i=0;i<pNbr;i++) {
    v4[i]=v3[i];
    v3[i]=0;
  }
  
  sumdelta(v4); //v4
  
  for(i=0;i<pNbr;i++) {
    //v[i]+=v4[i];
    v2[i]+=v4[i];
    
    if(pTab[i].leaf==1) {
      glBegin(GL_POLYGON);
      {
	static float color[3]={1.0,0.0,0.0};
	double C;
	//color[0]=(float)i/pNbr;
	//color[0]=color[1]=color[2]=0.10*(i%10); //+(tabRec[h]+v[i]);
	if(cooll==0) 
	  C=cool1*v2[i]; //+0.02*(i%10);
	else if(cooll==1)
	  C=cool1*log(v2[i]+1.);
	else
	  C=cool1*log(1.+log(v2[i]+1.));
	color[0]=color[1]=color[2]=C;
	glColor3fv(color);
      }
      for(j=0;j<pTab[i].n;j++)
	glVertex3fv(pTab[i].v[j]);
      glEnd();
      
      /*
      glBegin(GL_LINES);
      {
	static float color[3]={1.0,0.0,0.0};
	vec3_t a;
	//color[0]=(float)i/pNbr;
	//color[0]=color[1]=color[2]=0.10*(i%10); //+(tabRec[h]+v[i]);
	vec3Copy(pTab[i].norm,a);
	vec3Scale_((i==l1?-0.6:-0.3),a);
	vec3Add_(pTab[i].moy,a);
	
	color[0]=color[1]=(i==l1?1.:0.4); //+0.02*(i%10);
	color[2]=0.; //+0.02*(i%10);
	glColor3fv(color);
	
	glVertex3fv(pTab[i].moy);
	glVertex3fv(a);
      }
      glEnd();
      */
      
    }
  }
  
  if(l0) lr++;
  
  if(lr%57 <= 8)
    iya+=550.; //r%pNbr]+=1;
  
  if(lr%57 >= 57-8)
    iya-=550.;
  
  if(lr%57==0) {l3=rand()%pNbr;iya=0.;}

  /*
    if(l0 && lr%100==0) {
    if(l1!=-1) v2[l1]-=300.;
    do{
    l1++;
    if(l1>=pNbr) l1=0;
    } while(pTab[l1].leaf==0);
    v2[l1]+=300.;
    }
  */
  
  subvect(v2,vlo);
  for(i=0;i<pNbr;i++) vl[i]=0;
  vl[l3]=iya;
  sumdelta2(vl);
  addvect(v2,vl);
  {float *vt;vt=vlo;vlo=vl;vl=vt;}
  
  //glPopMatrix();
  glutSwapBuffers();
  
  usleep(10000);

  if(r && r%300==0) { 
    long long int t;
    //printf("r=%d rate=%f \n",r,300.*CLOCKS_PER_SEC/((t=clock())-otime));
    otime=t;
  }
}  

void init(void)
{

}

void main2(void)
{
  otime=clock();
  
  r=0;
  while(1) {

    draw();
  }
      
}

static void calc(patch_t *pTab,int pNbr)
{
  int i,j;
  vec3_t m,n,o;
  vec_t s;
  
  for(i=0;i<pNbr;i++) {
    //printf("i=%d ",i);
    vec3Null(m);
    //printf("n=%d ",pTab[i].n); 
    if(pTab[i].n<=2) {printf("patch errone\n"); exit(1);}
    for(j=0;j<pTab[i].n;j++) {
      vec3Add_(pTab[i].v[j],m);
    }
    vec3Scale_(1./pTab[i].n,m);
    //vec3Print(m);
    vec3Copy(m,pTab[i].moy);
    vec3Copy(pTab[i].v[1],m);
    vec3Copy(pTab[i].v[2],n);
    vec3Sub_(pTab[i].v[0],m);
    vec3Sub_(pTab[i].v[1],n);
    vec3CrossProduct(m,n,o);
    s=vec3Length(o);
    //printf("s=%f\n",s);
    if(s==0.) { printf("%d: normale nulle\n",i);/*exit(1);*/}
    s=1./s;
    vec3Scale_(s,o);
    vec3Copy(o,pTab[i].norm);
    
    // calcul l'aire 
    vec3CrossProduct(pTab[i].v[pTab[i].n-1],pTab[i].v[0],m);
    for(j=1;j<pTab[i].n;j++) {
      vec3CrossProduct(pTab[i].v[j-1],pTab[i].v[j],n);
      vec3Add_(n,m);
    }
    pTab[i].aera=0.5*fabs(vec3DotProduct(m,pTab[i].norm));
  }
}


int main(int argc,char **argv)
{
  FILE *in;
  char filename[100];
  char ffmatname[100];
  float *vismat;
  int i;
  
  if(argc<3) {printf("usage: %s file.3dpPc file.ffmat\n",argv[0]);exit(1);}

  if(argc>1) {
    strcpy(filename,argv[1]);
    argc--;
    argv++;
  }

  if(argc>1) {
    strcpy(ffmatname,argv[1]);
    argc--;
    argv++;
  }
  
  loadPatch(filename);

  printf("%d Patches\n",pNbr);
  

  calc(pTab,pNbr);
  /*
  for(i=0;i<pNbr;i++) {
    int j;
    vec3_t s,v,v2,norm;
    float x;
    patch_t *p=&pTab[i];
    
    vec3Sub(p->v[1],p->v[0],v);
    vec3Sub(p->v[2],p->v[0],v2);
    vec3CrossProduct(v,v2,norm);
    x=vec3Length(norm);
    if(x==0.) printf("long null\n");//Error("longueur nulle");
    x=1./x;
    vec3Scale_(x,norm);
    vec3Copy(norm,p->norm);
    
    vec3CrossProduct(p->v[p->n-1],p->v[0],s);
    for(j=1;j<p->n;j++) {
      vec3CrossProduct(p->v[j-1],p->v[j],v);
      vec3Add_(v,s);
    }
    p->aera=fabs(0.5*vec3DotProduct(s,p->norm));
  }
  */
  
  //mat=calcLum(pTab,pNbr);
  
  if((in=fopen(ffmatname,"rb"))==NULL) Error("erreur lecture out");
  
  //fread(&pNbr,sizeof(int),1,in);
  printf("%d\n",pNbr);
  if((tabskip=(lala_t*)malloc(sizeof(lala_t)*(pNbr+1)))==NULL) Error("out of memory");
  fread(tabskip,sizeof(lala_t),pNbr+1,in);
  if(tabskip[0].skip!=0) Error("tabskip[0]!=0");
  printf("taille totale = %d\n",tabskip[pNbr].skip);
  if((mat=(lala_t*)malloc(sizeof(lala_t)*tabskip[pNbr].skip))==NULL) Error("");
  fread(mat,sizeof(lala_t),tabskip[pNbr].skip,in);
  
  fclose(in);
  
  printf("matrice chargee\n");
  
  v=(float*)malloc(sizeof(float)*pNbr);
  v2=(float*)malloc(sizeof(float)*pNbr);
  v3=(float*)malloc(sizeof(float)*pNbr);
  v4=(float*)malloc(sizeof(float)*pNbr);
  
  vlo=(float*)malloc(sizeof(float)*pNbr);
  vl=(float*)malloc(sizeof(float)*pNbr);
  
  for(i=0;i<pNbr;i++) {
    v[i]=v2[i]=v3[i]=0.;
    vl[i]=vlo[i]=0.;
  }
  
  //v2[0]=2500;
  //sumdelta2(v2);
  //sumdelta(v2);
  //for(i=0;i<=100;i++) printf("%d : %f\n",i,v2[i]);
  
  
  //v2[142]=10.;
  
  /*for(i=0;i<(pNbr*pNbr);i++)
    printf("%d -> %d : %f\n",i/pNbr,i%pNbr,vismat[i]);
  */
  
  /***************/
  
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_DEPTH | GLUT_DOUBLE);
  
  glutInitWindowPosition(100, 100);
  glutInitWindowSize(600, 600);
  glutCreateWindow("Test");
  init();
  
  {
    static GLfloat pos[4] =
    {0.0, 0.0, 0.0, 0.0};
    glLightfv(GL_LIGHT0, GL_POSITION, pos);
  }
  glEnable(GL_CULL_FACE);
  //glEnable(GL_LIGHTING);
  //glEnable(GL_LIGHT0);
  glEnable(GL_DEPTH_TEST);

  glEnable(GL_NORMALIZE);
  
  if (argc > 1 && strcmp(argv[1], "-info")==0) {
    printf("GL_RENDERER   = %s\n", (char *) glGetString(GL_RENDERER));
    printf("GL_VERSION    = %s\n", (char *) glGetString(GL_VERSION));
    printf("GL_VENDOR     = %s\n", (char *) glGetString(GL_VENDOR));
    printf("GL_EXTENSIONS = %s\n", (char *) glGetString(GL_EXTENSIONS));
  }

  glutDisplayFunc(draw);
  glutReshapeFunc(reshape);
  glutKeyboardFunc(key);
  glutSpecialFunc(special);
  glutVisibilityFunc(visible);

  glutMainLoop();

  return 0;
}

