#ifndef _VECT_H
#define _VECT_H

#include <math.h>

typedef float vec_t;
typedef vec_t vec3_t[3];
typedef vec_t vec2_t[2];

#define vec3Print(v) printf("%.2f %.2f %.2f\n",(v)[0],(v)[1],(v)[2])

#define vec3Add_(v1,v2) {(v2)[0]+=(v1)[0];(v2)[1]+=(v1)[1];(v2)[2]+=(v1)[2];}
#define vec3Add(v1,v2,v3) {(v3)[0]=(v1)[0]+(v2)[0];(v3)[1]=(v1)[1]+(v2)[1];(v3)[2]=(v1)[2]+(v2)[2];}

#define vec3Sub_(v1,v2) {(v2)[0]-=(v1)[0];(v2)[1]-=(v1)[1];(v2)[2]-=(v1)[2];}
#define vec3Sub(v1,v2,v3) {(v3)[0]=(v1)[0]-(v2)[0];(v3)[1]=(v1)[1]-(v2)[1];(v3)[2]=(v1)[2]-(v2)[2];}

#define vec3CrossProduct(v1,v2,v3) { \
  (v3)[0]=(v1)[1]*(v2)[2]-(v1)[2]*(v2)[1]; \
  (v3)[1]=(v1)[2]*(v2)[0]-(v1)[0]*(v2)[2]; \
  (v3)[2]=(v1)[0]*(v2)[1]-(v1)[1]*(v2)[0];}\

#define vec3DotProduct(v1,v2) ((v1)[0]*(v2)[0]+(v1)[1]*(v2)[1]+(v1)[2]*(v2)[2])

#define vec3Copy(v1,v2) {(v2)[0]=(v1)[0];(v2)[1]=(v1)[1];(v2)[2]=(v1)[2];}

#define vec3Scale_(a,v1) {(v1)[0]*=(a);(v1)[1]*=(a);(v1)[2]*=(a);}

#define vec3Opp_(v) {(v)[0]=-(v)[0];(v)[1]=-(v)[1];(v)[2]=-(v)[2];}

#define vec3Null(v) {(v)[0]=(v)[1]=(v)[2]=0;}

#define vec3Length(v) (sqrt((v)[0]*(v)[0]+(v)[1]*(v)[1]+(v)[2]*(v)[2]))

#endif
