#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "patch.h"
//#include "lum.h"
#include "util.h"
#include "calc.h"

/*
  #define HMAX 100
  #define FMAX 2
  #define FFEPS 0.00000001
  
  int tabInd[HMAX];
  int tabRec[HMAX][FMAX];
*/  

//#define TESTORIG

typedef struct {
  //unsigned short ff;
  float ff;
  //unsigned short skip;
  int skip;
#ifdef TESTORIG
  unsigned short orig;
  unsigned short orig2;
#endif
} lala_t;

typedef struct {
  //unsigned short ff;
  float ff;
  //unsigned short skip;
  //int skip;
  int leaf;
} lala2_t;

static curskip=0;
static lala_t *tabskip;

static FILE *out;

int occlusion(int i,int j)
{
  int oc=0;
  int k,l;
  
  vec3_t a,b,vi,vj,c,d,e,f,ni,nj;

  if(pTab[i].origPatch==pTab[j].origPatch) oc=1;
  else {

    //return 0;
    
    vec3Copy(pTab[i].moy,vi);
    vec3Copy(pTab[j].moy,vj);
    
    // il faut que les 2 patchs soients orientees l'un vers l'autre
    vec3Copy(vj,a);
    vec3Sub_(vi,a);
    vec3Copy(a,b);
    vec3Opp_(b);
    vec3Null(ni);
    vec3Add_(pTab[i].norm,ni);
    vec3Null(nj);
    vec3Add_(pTab[j].norm,nj);

    if(vec3DotProduct(ni/*pTab[i].norm*/,a)<0 
       && vec3DotProduct(nj/*pTab[j].norm*/,b)<0) {
      //printf("teste %d - %d\n",i,j);

      //return 0;
      for(k=0;k<opNbr;k++) {
	if(k!=pTab[i].origPatch && k!=pTab[j].origPatch) {
	  vec3Copy(opTab[k].moy,c);
	  vec3Copy(c,d);
	  vec3Sub_(vi,c);
	  vec3Sub_(vj,d);
	  if(vec3DotProduct(ni/*pTab[i].norm*/,c)<0 
	     && vec3DotProduct(nj/*pTab[j].norm*/,d)<0) {
	    int s=1;
	    for(l=0;l<opTab[k].n;l++) {
	      vec3Copy(opTab[k].v[l],e);
	      vec3Copy(opTab[k].v[(l+1)%opTab[k].n],f);
	      vec3Sub_(vi,e);
	      vec3Sub_(vi,f);
	      vec3CrossProduct(e,f,c);
	      if(vec3DotProduct(a,c)>0.) {s=0;break;}
	    }
	    if(s) { oc=1; break; }
	  }
	}
      }
    } else oc=1;
  }
  return oc;
}

double ffaprox(int i,int j)
{
  /* Remplacer par exact point to patch FF */

  double ff;

  vec3_t vi,vj,a;
  double len;
  
  if(occlusion(i,j)) {
    ff=0.;
    //printf("occlusion");
  }
  else {
    vec3Copy(pTab[i].moy,vi);
    vec3Copy(pTab[j].moy,vj);
    
    vec3Copy(vj,a);
    vec3Sub_(vi,a);
    len=vec3Length(a);
    //printf("l=%f",len);
    if(len==0.) {
      len=0.01; 
      //exit(1);
    }
    ff=1./(len*len);
    vec3Scale_(1./len,a);
    ff*=-vec3DotProduct(a,pTab[i].norm)*vec3DotProduct(a,pTab[j].norm);
    ff*=pTab[j].aera;
    
    //if((ff/**pTab[j].aera*/)>0.5) 
    //  ff=0.5/*/pTab[j].aera*/;
    //ff=(0.5/40*ff);//*(1<<15);
    ff*=0.5/3.14;
  }
  return ff;
}

void ffpatchall(int i,lala2_t *tab)
{
  int j;
  double sumff=0.;
  
  for(j=0;j<pNbr;j++) 
    if(pTab[j].leaf==1) {
      //pTab[j].ff=ffaprox(i,j);
      sumff+=tab[j].ff=ffaprox(i,j);
      //printf("%f ",tab[j].ff);
    }
    else tab[j].ff=0.;
  if(sumff>=1.)
    printf("%d : sumff=%f\n",i,sumff);
}

#define HMAX 100
#define FMAX 4
#define FFEPS 0.0003

void delta(lala2_t *tabp,int i/*,lala_t lala*/)
{
  int j,k;

  int tabInd[HMAX];
  int tabRec[HMAX][FMAX];
  int h;
  int itab;
  lala_t *tab_;
  lala2_t *tab;

  double sumff=0.;
  
  //printf("write\n");

  if((tab=(lala2_t*)malloc(sizeof(lala2_t)*(pNbr+1)))==NULL) Error("out of memory");
  for(j=0;j<pNbr;j++)
    tab[j]=tabp[j];

  if(tabskip[i].skip!=-1) {printf("Erreur patch %i ecrit plusieurs fois\n",i); exit(1);}

  if((tab_=(lala_t*)malloc(sizeof(lala_t)*(pNbr+1)))==NULL) Error("out of memory");

  for(j=0;j<HMAX;j++)
    tabInd[j]=0;

  itab=0;
  tab_[0].skip=0;
  h=0;
  
  for(j=0;j<pNbr;j++) {
    
    tab[j].leaf=pTab[j].leaf;
    //tab[j].ff=0.;
    
    tabRec[h][tabInd[h]]=j;
    
    if(h>=HMAX) Error("h>=HMAX");
    
    if(pTab[j].leaf==0) {
      h++;
    } else {
      tabInd[h]++;
      while(h && tabInd[h]==FMAX) {
	tabInd[h]=0;
	{
	  double min,max;
	  double s=0.;//,s2=0.;
	  double t;
	  int fin=1;
	  
	  for(k=0;k<FMAX;k++) {
	    s+=t=tab[tabRec[h][k]].ff;
	    //s2+=tab[tabRec[h][k]].ff2;
	    //if(tabff[tabRec[h][k]].leaf!=1) fin=0;
	    if(tab[tabRec[h][k]].leaf!=1) fin=0;
	    if(k==0) min=max=t;
	    else {
	      if(min>t) min=t;
	      if(max<t) max=t;
	    }
	  }
	  
	  tab[tabRec[h-1][tabInd[h-1]]].ff=s;// /FMAX;
	  //tabff[tabRec[h-1][tabInd[h-1]]].ff2=s2/FMAX;
	  
	  
	  if(fin && 
	     //pTab[i].aera *		 
	     pTab[tabRec[h-1][tabInd[h-1]]].aera * 
	     (max-min) <FFEPS) {
	    for(k=0;k<FMAX;k++)
	      tab[tabRec[h][k]].leaf=-1;
	    tab[tabRec[h-1][tabInd[h-1]]].leaf=1;
	    
	  }
	  else {
	    //tab[tabRec[h-1][tabInd[h-1]]].ff=0.;
	    for(k=0;k<FMAX;k++)
	      tab[tabRec[h][k]].ff-=tab[tabRec[h-1][tabInd[h-1]]].ff/FMAX;
	  }
	  
	}
	h--;
	tabInd[h]++;
      }
    }
    
    
    if(h==0) {
      //printf("coucou\n");
      //if(tab[tabRec[0][0]].ff==0. && tab[tabRec[0][0]].leaf==1) {
      //tab[tabRec[0][0]].leaf=-1;
      //}
      for(k=tabRec[0][0];k<=j;k++) {
	if(tab[k].leaf!=-1) {
	  tab_[itab].ff=tab[k].ff;
	  tab_[itab+1].skip=0;
#ifdef TESTORIG
	  tab_[itab].orig=k;
	  tab_[itab].orig2=i;
#endif
	  sumff+=fabs(tab[k].ff);
	  itab++;
	} else {
	  //printf("error\n");
	  tab_[itab].skip++;
	}
      }
      tabInd[0]=0;
    }
   }
  
  /*if(i==0) {
    for(k=0;k<itab+1;k++)
    printf("%f %d\n",tab_[k].ff,tab_[k].skip);
    }*/

  itab++;
  //printf("write i=%d itab=%d\n",i,itab);

  {
    //stats
    static long long nbrt=0;
    nbrt+=itab;
    if(i && 0==i%100) {
      long long est=(nbrt*sizeof(lala_t))/(i+1)*pNbr;
      printf("%d/%d\t: %Ld (%.2f%%) (estim=%.2f)\n",i,pNbr,nbrt*sizeof(lala_t),100*((double)nbrt)/(pNbr+1)/(i+1),est/1024./1024.);
    }
    
  }

  fwrite(tab_,sizeof(lala_t),itab,out);
  
  tabskip[i].skip=curskip;
  tabskip[i].ff=sumff;
  curskip+=itab;
  
  //printf("skip=%d\n",curskip);
  
  free(tab_);
  free(tab);
}

/* test occlusion rapide ( on a pas sum(vecteurs des fils)=0 )*/
void calcLum(/*patch_t *pTab,int pNbr,patch_t *opTab,int opNbr,*/char *filename)
{
  int i,j;
  int tabInd[HMAX];
  int tabRec[HMAX][FMAX];
  //FILE *out;
  //int *tabskip;
  //int curskip=0;
  lala2_t *tabff,*tabff2;
  
  //lala2_t (*tabRec2[HMAX][FMAX]);
  //double (*tabRec2[HMAX][FMAX]);
  lala2_t (*tabRec2[HMAX]);
  int tabInd2[HMAX];
  int h2;
  //int tabRec2_[HMAX][FMAX];
  
  if((out=fopen(filename,"wb"))==NULL) Error("open file");
  if((tabskip=(lala_t*)malloc(sizeof(lala_t)*(pNbr+1)))==NULL) Error("out of memory");
  for(i=0;i<pNbr;i++) tabskip[i].skip=-1;
  
  fwrite(tabskip,sizeof(lala_t),pNbr+1,out);
  
  for(i=0;i<HMAX;i++) {
    tabInd2[i]=0;
    tabRec2[i]=NULL;
  }

  if((tabff2=(lala2_t*)malloc(pNbr*sizeof(lala2_t)))==NULL)  Error("out of memory");

  
  h2=0;
  
  for(i=0;i<pNbr;i++) { 
    //printf("i=%d \n",i);

    //if(i==340) exit(0);

    if(h2>=HMAX) Error("h2>=HMAX");
    
    if((tabff=(lala2_t*)malloc(pNbr*sizeof(lala2_t)))==NULL)  Error("out of memory"); 
    
    ffpatchall(i,tabff);
    
    if(h2==0) { delta(tabff,i); }
    else {
      for(j=0;j<pNbr;j++) {
	tabff2[j].ff=tabff[j].ff-tabRec2[h2-1][j].ff;
      }
      delta(tabff2,i);
    }
    
    //printf("10\n");

    if(tabInd2[h2]) 
      {
	free(tabRec2[h2]);
	tabRec2[h2]=NULL;
      }
    
    if(tabRec2[h2]!=NULL) Error("!=NULL");
    tabRec2[h2]=tabff;
    
    if(pTab[i].leaf==1) {
      //printf("leaf\n");
      tabInd2[h2]++;
      while(tabInd2[h2]==FMAX && h2) {
	tabInd2[h2]=0;
	free(tabRec2[h2]);
	tabRec2[h2]=NULL;
	h2--;
	tabInd2[h2]++;
      }
      if(h2==0) {
	tabInd2[0]=0;
	free(tabRec2[0]);
	tabRec2[0]=NULL;
      }
    }
    else
      h2++;

    
    /*
    {
      int k;
      printf("h2=%d\n",h2);
      for(k=0;k<10;k++)
	printf("%d ",tabInd2[k]);
      printf("\n");
    }
    */
    
      
    //printf("20\n");

  }
  
  fseek(out,0,SEEK_SET);
  tabskip[pNbr].skip=curskip;
  fwrite(tabskip,sizeof(lala_t),pNbr+1,out);
  free(tabskip);

  free(tabff2);

  fclose(out);
}

/*
void calcLum__(patch_t *pTab,int pNbr,patch_t *opTab,int opNbr,char *filename)
{
  int i,j,k,l,h;
  lala_t *tab;
  int itab;
  vec3_t vi,vj;
  vec3_t a,b,c,d,e,f;
  float len,ff;
  FILE *out;
  int *tabskip;
  int curskip=0;

  if((out=fopen(filename,"wb"))==NULL) Error("");
  if((tabskip=(int*)malloc(sizeof(int)*pNbr))==NULL) Error("out of memory");
  
  fwrite(tabskip,sizeof(int),pNbr,out);
  
  calc(pTab,pNbr);
  
  //if((tab=(float*)malloc(sizeof(float)*pNbr*pNbr))==0) Error("");
  if((tab=(lala_t*)malloc(sizeof(lala_t)*(pNbr+1)))==NULL) Error("out of memory");

  for(i=0;i<pNbr;i++) { 
    printf("i=%d ",i);
    
    for(j=0;j<pNbr;j++)
      pTab[j].leaf2=pTab[j].leaf;

    //for(j=i+1;j<pNbr;j++) {
    for(j=0;j<pNbr;j++) if(pTab[j].leaf==1) {
      pTab[j].ff=ffaprox(i,j);
      //printf("%f ",pTab[j].ff);
    }
    
    for(j=0;j<HMAX;j++)
      tabInd[j]=0;
    
    itab=0;
    tab[0].skip=0;
    h=0;
    for(j=0;j<pNbr;j++) {
      tabRec[h][tabInd[h]]=j;
      
      if(pTab[j].leaf==0) {
	h++;
      } else {
	tabInd[h]++;
	while(h && tabInd[h]==FMAX) {
	  tabInd[h]=0;
	  {
	    //unsigned short int min,max,s=0,t;
	    float min,max;
	    float s=0;
	    float t;
	    int fin=1;

	    for(k=0;k<FMAX;k++) {
	      s+=t=pTab[tabRec[h][k]].ff;
	      if(pTab[tabRec[h][k]].leaf2!=1) fin=0;
	      if(k==0) min=max=t;
	      else {
		if(min>t) min=t;
		if(max<t) max=t;
	      }
	    }
	    
	    if(fin && (max-min) <= FFEPS) {
		pTab[tabRec[h-1][tabInd[h-1]]].ff=s/FMAX;
		for(k=0;k<FMAX;k++)
		  pTab[tabRec[h][k]].leaf2=-1;
		pTab[tabRec[h-1][tabInd[h-1]]].leaf2=1;
	    }
	    else {
	      pTab[tabRec[h-1][tabInd[h-1]]].ff=min;
	      for(k=0;k<FMAX;k++)
		pTab[tabRec[h][k]].ff-=min;
	    }
	    
	  }
	  h--;
	  tabInd[h]++;
	}
      }
      
      if(h==0) {
	for(k=tabRec[0][0];k<=j;k++) {
	  if(pTab[k].leaf2!=-1) {
	    tab[itab].ff=pTab[k].ff;
	    tab[itab+1].skip=0;
	    itab++;
	  } else 
	    tab[itab].skip++;
	}
	tabInd[0]=0;
      }  
    }
    
    fwrite(tab,sizeof(lala_t),itab,out);
    
    curskip+=itab;
    tabskip[i]=curskip;
   
    printf("itab=%d  %%=%3.2f\n",itab,100.*itab/pNbr);
  }
  
  fseek(out,0,SEEK_SET);
  fwrite(tabskip,sizeof(int),pNbr,out);

  fclose(out);

  free(tab);
}
*/
