#include <stdio.h>
#include "lum.h"
#include "util.h"

#define HMAX 100
#define FMAX 2
//#define FFEPS 32
#define FFEPS 0.00000001

int tabInd[HMAX];
int tabRec[HMAX][FMAX];

typedef struct {
  //unsigned short ff;
  float ff;
  // FIX ?
  //unsigned short skip;
  int skip;
} lala_t;

static void calc(patch_t *pTab,int pNbr)
{
  int i,j;
  vec3_t m,n,o;
  vec_t s;
  
  for(i=0;i<pNbr;i++) {
    //printf("i=%d ",i);
    vec3Null(m);
    //printf("n=%d ",pTab[i].n); 
    if(pTab[i].n<=2) {printf("patch errone\n"); exit(1);}
    for(j=0;j<pTab[i].n;j++) {
      vec3Add_(pTab[i].v[j],m);
    }
    vec3Scale_(1./pTab[i].n,m);
    //vec3Print(m);
    vec3Copy(m,pTab[i].moy);
    vec3Copy(pTab[i].v[1],m);
    vec3Copy(pTab[i].v[2],n);
    vec3Sub_(pTab[i].v[0],m);
    vec3Sub_(pTab[i].v[1],n);
    vec3CrossProduct(m,n,o);
    s=vec3Length(o);
    //printf("s=%f\n",s);
    if(s==0.) { printf("erreur normale nulle\n");exit(1);}
    s=1./s;
    vec3Scale_(s,o);
    vec3Copy(o,pTab[i].norm);
    
    // calcul l'aire 
    vec3CrossProduct(pTab[i].v[pTab[i].n-1],pTab[i].v[0],m);
    for(j=1;j<pTab[i].n;j++) {
      vec3CrossProduct(pTab[i].v[j-1],pTab[i].v[j],n);
      vec3Add_(n,m);
    }
    pTab[i].aera=0.5*fabs(vec3DotProduct(m,pTab[i].norm));
  }
}

void calcLum(patch_t *pTab,int pNbr,patch_t *opTab,int opNbr,char *filename)
{
  int i,j,k,l,h;
  lala_t *tab;
  int itab;
  vec3_t vi,vj;
  vec3_t a,b,c,d,e,f;
  float len,ff;
  FILE *out;
  int *tabskip;
  int curskip=0;

  if((out=fopen(filename,"wb"))==NULL) Error("");
  if((tabskip=(int*)malloc(sizeof(int)*pNbr))==NULL) Error("");
  
  fwrite(tabskip,sizeof(int),pNbr,out);
  
  calc(pTab,pNbr);
  
  //if((tab=(float*)malloc(sizeof(float)*pNbr*pNbr))==0) Error("");
  if((tab=(lala_t*)malloc(sizeof(lala_t)*(pNbr+1)))==NULL) Error("");

  for(i=0;i<pNbr;i++) { 
    printf("i=%d ",i);
    
    for(j=0;j<pNbr;j++)
      pTab[j].leaf2=pTab[j].leaf;

    //for(j=i+1;j<pNbr;j++) {
    for(j=0;j<pNbr;j++) if(pTab[j].leaf==1) {
      int oc=0;
      if(pTab[i].origPatch==pTab[j].origPatch) oc=1;
      else {
	vec3Copy(pTab[i].moy,vi);
	vec3Copy(pTab[j].moy,vj);
	
	// il faut que les 2 patchs soients orientees l'un vers l'autre
	vec3Copy(vj,a);
	vec3Sub_(vi,a);
	vec3Copy(a,b);
	vec3Opp_(b);
	if(vec3DotProduct(pTab[i].norm,a)>0 
	   && vec3DotProduct(pTab[j].norm,b)>0) {
	  //printf("teste %d - %d\n",i,j);
	  for(k=0;k<opNbr;k++) {
	    if(k!=pTab[i].origPatch && k!=pTab[j].origPatch) {
	      vec3Copy(opTab[k].moy,c);
	      vec3Copy(c,d);
	      vec3Sub_(vi,c);
	      vec3Sub_(vj,d);
	      if(vec3DotProduct(pTab[i].norm,c)>0 
		 && vec3DotProduct(pTab[j].norm,d)>0) {
		int s=1;
		for(l=0;l<opTab[k].n;l++) {
		  vec3Copy(opTab[k].v[l],e);
		  vec3Copy(opTab[k].v[(l+1)%opTab[k].n],f);
		  vec3Sub_(vi,e);
		  vec3Sub_(vi,f);
		  vec3CrossProduct(e,f,c);
		  if(vec3DotProduct(a,c)<0.) {s=0;break;}
		}
		if(s) { oc=1; break; }
	      }
	    }
	  }
	} else oc=1;
      }
      if(oc)
	pTab[j].ff=0;
      else {
	vec3Copy(vj,a);
	vec3Sub_(vi,a);
	len=vec3Length(a);
	if(len==0.) len=0.01; //exit(1);
	ff=1./(len*len);
	vec3Scale_(1./len,a);
	ff*=-vec3DotProduct(a,pTab[i].norm)*vec3DotProduct(a,pTab[j].norm);
	if((ff*pTab[j].aera)>0.5) ff=0.5/pTab[j].aera;
	pTab[j].ff=(0.5/40*ff);//*(1<<15);
      }
      //printf("%f ",pTab[j].ff);
    }
    
    for(j=0;j<HMAX;j++)
      tabInd[j]=0;
    
    itab=0;
    tab[0].skip=0;
    h=0;
    for(j=0;j<pNbr;j++) {
      tabRec[h][tabInd[h]]=j;
      
      if(pTab[j].leaf==0) {
	h++;
      } else {
	tabInd[h]++;
	while(h && tabInd[h]==FMAX) {
	  tabInd[h]=0;
	  {
	    //unsigned short int min,max,s=0,t;
	    float min,max;
	    float s=0;
	    float t;
	    int fin=1;

	    for(k=0;k<FMAX;k++) {
	      s+=t=pTab[tabRec[h][k]].ff;
	      if(pTab[tabRec[h][k]].leaf2!=1) fin=0;
	      if(k==0) min=max=t;
	      else {
		if(min>t) min=t;
		if(max<t) max=t;
	      }
	    }
	    
	    if(fin && (max-min) <= FFEPS) {
		pTab[tabRec[h-1][tabInd[h-1]]].ff=s/FMAX;
		for(k=0;k<FMAX;k++)
		  pTab[tabRec[h][k]].leaf2=-1;
		pTab[tabRec[h-1][tabInd[h-1]]].leaf2=1;
	    }
	    else {
	      pTab[tabRec[h-1][tabInd[h-1]]].ff=min;
	      for(k=0;k<FMAX;k++)
		pTab[tabRec[h][k]].ff-=min;
	    }
	    
	  }
	  h--;
	  tabInd[h]++;
	}
      }
      
      if(h==0) {
	for(k=tabRec[0][0];k<=j;k++) {
	  if(pTab[k].leaf2!=-1) {
	    tab[itab].ff=pTab[k].ff;
	    tab[itab+1].skip=0;
	    itab++;
	  } else 
	    tab[itab].skip++;
	}
	tabInd[0]=0;
      }  
    }
    
    fwrite(tab,sizeof(lala_t),itab,out);
    
    curskip+=itab;
    tabskip[i]=curskip;
   
    printf("itab=%d  %%=%3.2f\n",itab,100.*itab/pNbr);
  }
  
  fseek(out,0,SEEK_SET);
  fwrite(tabskip,sizeof(int),pNbr,out);

  fclose(out);

  free(tab);
}
