#include <stdio.h>
#include "lum.h"
#include "util.h"

#define HMAX 100
#define FMAX 4
//#define FFEPS 32
//#define FFEPS 0.0000001
//#define FFEPS 0.0001
#define FFEPS 0.01

int tabInd[HMAX];
int tabRec[HMAX][FMAX];
static curskip=0;

typedef struct {
  //unsigned short ff;
  float ff;
  // FIX ?
  //unsigned short skip;
  int skip;
} lala_t;

typedef struct {
  float ff;
  float ff2;
  int leaf;
} lala2_t;

lala_t *tabskip;

static void calc(patch_t *pTab,int pNbr)
{
  int i,j;
  vec3_t m,n,o;
  vec_t s;
  
  for(i=0;i<pNbr;i++) {
    //printf("i=%d ",i);
    vec3Null(m);
    //printf("n=%d ",pTab[i].n); 
    if(pTab[i].n<=2) {printf("patch errone\n"); exit(1);}
    for(j=0;j<pTab[i].n;j++) {
      vec3Add_(pTab[i].v[j],m);
    }
    vec3Scale_(1./pTab[i].n,m);
    //vec3Print(m);
    vec3Copy(m,pTab[i].moy);
    vec3Copy(pTab[i].v[1],m);
    vec3Copy(pTab[i].v[2],n);
    vec3Sub_(pTab[i].v[0],m);
    vec3Sub_(pTab[i].v[1],n);
    vec3CrossProduct(m,n,o);
    s=vec3Length(o);
    //printf("s=%f\n",s);
    if(s==0.) { printf("erreur normale nulle\n");exit(1);}
    s=1./s;
    vec3Scale_(s,o);
    vec3Copy(o,pTab[i].norm);
    
    // calcul l'aire 
    vec3CrossProduct(pTab[i].v[pTab[i].n-1],pTab[i].v[0],m);
    for(j=1;j<pTab[i].n;j++) {
      vec3CrossProduct(pTab[i].v[j-1],pTab[i].v[j],n);
      vec3Add_(n,m);
    }
    pTab[i].aera=0.5*fabs(vec3DotProduct(m,pTab[i].norm));
  }
}

void writemat(FILE *out,lala2_t *tabff,patch_t *pTab,int pNbr,lala_t *tab,int i)
{
  int j,k;
  int itab;
  int tabInd[HMAX];
  int tabRec[HMAX][FMAX];
  int h;

  float sumff=0;
   
  if(tabskip[i].skip!=-1) {printf("Erreur patch %i ecrit plusieurs fois\n",i); exit(1);}

  for(j=0;j<HMAX;j++)
    tabInd[j]=0;
  
  itab=0;
  tab[0].skip=0;
  h=0;
  for(j=0;j<pNbr;j++) {
    tabRec[h][tabInd[h]]=j;
    
    if(pTab[j].leaf==0) {
      h++;
    } else {
      tabInd[h]++;
      while(h && tabInd[h]==FMAX) {
	tabInd[h]=0;
	{
	  //unsigned short int min,max,s=0,t;
	  float min,max;
	  float s=0,s2=0;
	  float t;
	  int fin=1;
	  
	  for(k=0;k<FMAX;k++) {
	    s+=t=tabff[tabRec[h][k]].ff;
	    s2+=tabff[tabRec[h][k]].ff2;
	    if(tabff[tabRec[h][k]].leaf!=1) fin=0;
	    if(k==0) min=max=t;
	    else {
	      if(min>t) min=t;
	      if(max<t) max=t;
	    }
	  }
	  
	  tabff[tabRec[h-1][tabInd[h-1]]].ff=s/FMAX;
	  tabff[tabRec[h-1][tabInd[h-1]]].ff2=s2/FMAX;
	  
	  //if(fin) {
	    //if(max!=0 && ((max-min)/max) < 0.01 )
	  //if(min!=0. && max !=0.)
	  // printf("%.9f %.9f %.9f\n",min,max,(max-min)/max);
	    //else min==0 ? printf("0\n") : printf("Inf\n");
	  //}
	  
	  //if(fin && max == 0. && min == 0.) {
	  //if(fin && max == min ) {
	  //if(fin && ((max == min ) || ( (max-min) <= FFEPS))) {
	  //if(fin && ( (max==min) || (max!=0 && ((max-min)/fabs(max)) < 0.3 ))) {
	  if(fin && ( (max==min) || (max!=0 && ((max-min)/fabs(tabff[tabRec[h-1][tabInd[h-1]]].ff2)) < 0.25 ))) {
	    //if(fin && ( (max==min) || (pTab[tabRec[h-1][tabInd[h-1]]].aera*fabs(tabff[tabRec[h-1][tabInd[h-1]]].ff2)) < FFEPS )) {
	    //if(fin && ( (max==min) || (max!=0 && ((max-min)/fabs(max)) < 0.3 ))) {
	    for(k=0;k<FMAX;k++)
	      tabff[tabRec[h][k]].leaf=-1;
	    tabff[tabRec[h-1][tabInd[h-1]]].leaf=1;
	  }
	  else {
	    tabff[tabRec[h-1][tabInd[h-1]]].ff=0;
	    //for(k=0;k<FMAX;k++)
	    //tabff[tabRec[h][k]].ff-=tabff[tabRec[h-1][tabInd[h-1]]].ff;
	  }
	    
	}
	h--;
	tabInd[h]++;
      }
    }
    
    if(h==0) {
      if(tabff[tabRec[0][0]].ff==0. && tabff[tabRec[0][0]].leaf==1) {
	tabff[tabRec[0][0]].leaf=-1;
      }
      for(k=tabRec[0][0];k<=j;k++) {
	if(tabff[k].leaf!=-1) {
	  tab[itab].ff=tabff[k].ff;
	  tab[itab+1].skip=0;
	  sumff+=fabs(tabff[k].ff);
	  itab++;
	} else
	  tab[itab].skip++;
      }
      tabInd[0]=0;
    }
  }
  
  itab++;
  printf("write i=%d itab=%d\n",i,itab);
  
  fwrite(tab,sizeof(lala_t),itab,out);
  
  tabskip[i].skip=curskip;
  tabskip[i].ff=sumff;
  curskip+=itab;
}

void calcLum(patch_t *pTab,int pNbr,patch_t *opTab,int opNbr,char *filename)
{
  int i,j,k,l,h;
  lala_t *tab;
  int itab;
  vec3_t vi,vj;
  vec3_t a,b,c,d,e,f;
  double len,ff;
  FILE *out;
  //int curskip=0;
  lala2_t *tabff;
  double sumff;

  lala2_t (*tabRec2[HMAX][FMAX]);
  int tabInd2[HMAX];
  int h2;
  int tabRec2_[HMAX][FMAX];

  if((out=fopen(filename,"wb"))==NULL) Error("");
  
  if((tabskip=(lala_t*)malloc(sizeof(lala_t)*(pNbr+1)))==NULL) Error("");
  for(i=0;i<pNbr;i++) tabskip[i].skip=-1;
  
  fwrite(tabskip,sizeof(lala_t),pNbr+1,out);
  
  calc(pTab,pNbr);
  calc(opTab,opNbr);
  
  if((tab=(lala_t*)malloc(sizeof(lala_t)*(pNbr+1)))==NULL) Error("");
  //if((tabff=(lala2_t*)malloc(sizeof(lala2_t)*(pNbr+1)))==NULL) Error("");

  for(i=0;i<HMAX;i++)
    tabInd2[i]=0;

  h2=0;

  for(i=0;i<pNbr;i++) {
    //printf("i=%d ",i);
    tabRec2_[h2][tabInd2[h2]]=i;
    if(pTab[i].leaf==1) {
      if((tabff=(lala2_t*)malloc(sizeof(lala2_t)*(pNbr+1)))==NULL) Error(""); 
      tabRec2[h2][tabInd2[h2]]=tabff;

      sumff=0;
    
      for(j=0;j<pNbr;j++)
	tabff[j].leaf=pTab[j].leaf;
    
      for(j=0;j<pNbr;j++) 
	if(pTab[j].leaf==1) {
	  int oc=0;
	  if(pTab[i].origPatch==pTab[j].origPatch) oc=1;
	  else {
	    vec3Copy(pTab[i].moy,vi);
	    vec3Copy(pTab[j].moy,vj);
	
	    // il faut que les 2 patchs soients orientees l'un vers l'autre
	    vec3Copy(vj,a);
	    vec3Sub_(vi,a);
	    vec3Copy(a,b);
	    vec3Opp_(b);
	    if(vec3DotProduct(pTab[i].norm,a)>0 
	       && vec3DotProduct(pTab[j].norm,b)>0) {
	      //printf("teste %d - %d\n",i,j);
	      for(k=0;k<opNbr;k++) {
		if(k!=pTab[i].origPatch && k!=pTab[j].origPatch) {
		  vec3Copy(opTab[k].moy,c);
		  vec3Copy(c,d);
		  vec3Sub_(vi,c);
		  vec3Sub_(vj,d);
		  if(vec3DotProduct(opTab[k].norm,c)*vec3DotProduct(opTab[k].norm,d)<0) 
		    //if(vec3DotProduct(opTab[k].norm,c)>0 && vec3DotProduct(opTab[k].norm,d)<0) 
		    {
		      int s=1;
		      for(l=0;l<opTab[k].n;l++) {
			vec3Copy(opTab[k].v[l],e);
			vec3Copy(opTab[k].v[(l+1)%opTab[k].n],f);
			vec3Sub_(vi,e);
			vec3Sub_(vi,f);
			vec3CrossProduct(e,f,c);
			if(vec3DotProduct(a,c)<0.) {s=0;break;}
		      }
		      if(s) { oc=1; break; }
		    }
		}
	      }
	    } else oc=1;
	  }
	  if(oc)
	    tabff[j].ff=0;
	  else {
	    vec3Copy(vj,a);
	    vec3Sub_(vi,a);
	    len=vec3Length(a);
	    if(len==0.) len=0.00000001; //exit(1);
	    ff=1./(len*len);
	    vec3Scale_(1./len,a);
	    ff*=-vec3DotProduct(a,pTab[i].norm)*vec3DotProduct(a,pTab[j].norm);
	    ff*=2./(4.*M_PI);
	    if((ff*pTab[j].aera)>0.5) { 
	      ff=0.5/pTab[j].aera; 
	      printf("depassement\n");
	    }
	    tabff[j].ff=tabff[j].ff2=ff;
	    sumff+=ff*pTab[j].aera;
	  }
	  //printf("%f ",pTab[j].ff);
	}
    
      for(j=0;j<HMAX;j++)
	tabInd[j]=0;
    
      /*
	h=0;
	for(j=0;j<pNbr;j++) {
	tabRec[h][tabInd[h]]=j;
	
	if(pTab[j].leaf==0) {
	h++;
	} else {
	tabInd[h]++;
	while(h && tabInd[h]==FMAX) {
	tabInd[h]=0;
	{
	float s=0;
	
	for(k=0;k<FMAX;k++) {
	s+=tabff[tabRec[h][k]].ff;
	}
	
	tabff[tabRec[h-1][tabInd[h-1]]].ff=s/FMAX;
	
	for(k=0;k<FMAX;k++) {
	tabff[tabRec[h][k]].ff-=s/FMAX;
	}
	
	}
	h--;
	tabInd[h]++;
	}
	
	if(h==0) {
	tabInd[0]=0;
	}
	}
	}
      */

      //writemat(out,tabff,pTab,pNbr,tab,i);
      
      if(sumff>1.0) printf("i=%d DEPASSEMENT!!!\n",i);
      printf("i=%d sumff=%f\n",i,sumff);
      
      //printf(/*"itab=%d %3.2f %% "*/" sumff=%f\n"/*,itab,100.*itab/pNbr*/,sumff);
      
      tabInd2[h2]++;
      while(tabInd2[h2]==FMAX && h2) {
	tabInd2[h2]=0;
	{
	  int k,l;

	  if((tabff=(lala2_t*)malloc(sizeof(lala2_t)*(pNbr+1)))==NULL) Error(""); 
	  tabRec2[h2-1][tabInd2[h2-1]]=tabff;
	  for(k=0;k<pNbr;k++) {
	    tabff[k].ff=0.;
	    tabff[k].ff2=0.;
	    tabff[k].leaf=-1;
	    /*
	    tabff[k].leaf=pTab[k].leaf;
	    for(l=0;l<FMAX;l++) {
	      tabff[k].ff+=tabRec2[h2][l][k].ff;
	      tabff[k].ff2+=tabRec2[h2][l][k].ff;
	    }
	    tabff[k].ff/=FMAX;
	    tabff[k].ff2/=FMAX;
	    for(l=0;l<FMAX;l++)
	      tabRec2[h2][l][k].ff-=tabff[k].ff;
	    */
	  }

	  for(l=0;l<FMAX;l++) {
	    tabff=tabRec2[h2][l];
	    
	    writemat(out,tabff,pTab,pNbr,tab,tabRec2_[h2][l]);

	    free(tabff);
	      
	  }
	
	}
	  
	h2--;
	tabInd2[h2]++;
	
      }

      if(h2==0) {
	if(tabInd2[0]!=1) printf("erreur tabInd2[0]==%d\n",tabInd2[0]);
	tabff=tabRec2[0][0];
	writemat(out,tabff,pTab,pNbr,tab,tabRec2_[0][0]);
	tabInd2[0]=0;
	free(tabff);
      }

    } else {
      h2++;
    }

  }
  
  fseek(out,0,SEEK_SET);
  tabskip[pNbr].skip=curskip;
  fwrite(tabskip,sizeof(lala_t),pNbr+1,out);

  for(i=0;i<pNbr;i++) 
    if(tabskip[i].skip==-1) 
      printf("erreur patch %d pas ecrit\n",i);

  fclose(out);

  free(tabskip);
  free(tab);
}
