#include <stdio.h>
#include <string.h>
#include <stdlib.h>
//#include "lum.h"
#include "util.h"
#include "3dpPc.h"
#include "hpatch.h"
#include "calc.h"

patch_t *pTab;
int pNbr=0;
patch_t *opTab;
int opNbr=0;

static void calc(patch_t *pTab,int pNbr)
{
  int i,j;
  vec3_t m,n,o;
  vec_t s;
  
  for(i=0;i<pNbr;i++) {
    //printf("i=%d ",i);
    vec3Null(m);
    //printf("n=%d ",pTab[i].n); 
    if(pTab[i].n<=2) {printf("patch errone\n"); exit(1);}
    for(j=0;j<pTab[i].n;j++) {
      vec3Add_(pTab[i].v[j],m);
    }
    vec3Scale_(1./pTab[i].n,m);
    //vec3Print(m);
    vec3Copy(m,pTab[i].moy);
    vec3Copy(pTab[i].v[1],m);
    vec3Copy(pTab[i].v[2],n);
    vec3Sub_(pTab[i].v[0],m);
    vec3Sub_(pTab[i].v[1],n);
    vec3CrossProduct(m,n,o);
    s=vec3Length(o);
    //printf("s=%f\n",s);
    if(s==0.) { printf("%d: normale nulle\n",i);/*exit(1);*/}
    s=1./s;
    vec3Scale_(s,o);
    vec3Copy(o,pTab[i].norm);
    
    // calcul l'aire 
    vec3CrossProduct(pTab[i].v[pTab[i].n-1],pTab[i].v[0],m);
    for(j=1;j<pTab[i].n;j++) {
      vec3CrossProduct(pTab[i].v[j-1],pTab[i].v[j],n);
      vec3Add_(n,m);
    }
    pTab[i].aera=0.5*fabs(vec3DotProduct(m,pTab[i].norm));
  }
}

int main(int argc,char *argv[])
{
  FILE *out;
  char filename[100]="t0.map",filenameoc[100];
  float *vismat;
  int i;
  char outname[100];
  
  if(argc<=2) {printf("usage: %s file.hpatch file.3dpPc [out]\n",argv[0]);exit(1);}
  strcpy(filename,argv[1]);
  strcpy(filenameoc,argv[2]);
  
  loadPatch(filename,&pTab,&pNbr);
  load3dpPc(filenameoc,&opTab,&opNbr);

  if(argc>=4) strcpy(outname,argv[3]);
  else {
    strcpy(outname,argv[1]);
    for(i=strlen(outname)-1;i>=0 && outname[i]!='.';i--);
    if(i<0) strcpy(outname,"ffmat");
    else {
      outname[i]=0;
      strcat(outname,".ffmat");
    }
  }
  
  printf("%d Patches, %d Occluders\n",pNbr,opNbr);
  
  calc(pTab,pNbr);
  calc(opTab,opNbr);

  //calcLum(pTab,pNbr,opTab,opNbr,"out");
  calcLum(outname);

  freePatch(pTab,pNbr);
  free3dpPc(opTab,opNbr);
  
  return 0;
}
